<?php 
// Вывести настраиваемое редактируемое поле на страницах редактирования заказа в админке 
add_action( 'woocommerce_admin_order_data_after_order_details', 'editable_order_custom_field', 12, 1 );
function editable_order_custom_field( $order ){
    // Перебрать элементы заказа
    foreach( $order->get_items() as $item_id => $item ){
        // Получить "ссылку клиента" из метаданных позиции заказа
        if( $item->get_meta('Редактируемое поле') ){
            // Редактируемое поле
            $item_value = $item->get_meta('Редактируемое поле');

            // Мы выводим скрытое поле с идентификатором товара (чтобы иметь возможность обновлять метаданные этого заказа позже)
            echo '<input type="hidden" name="item_id_ref" value="' . $item_id . '">';

            break; // Мы останавливаемся
        }
    }

    // Получить "ссылку на клиента" из метаданных (не метаданных элемента)
    $updated_value = $order->get_meta('_customer_ref');

    // Замените значение «ссылка клиента» на метаданные, если они существуют
    $value = $updated_value ? $updated_value : ( isset($item_value) ? $item_value : '');

    // Показать настраиваемое редактируемое поле
    woocommerce_wp_text_input( array(
        'id'            => 'customer_ref',
        'label'         => __("Редактируемое поле:", "woocommerce"),
        'value'         => $value,
        'wrapper_class' => 'form-field-wide',
    ) );
}

// Сохраните значение настраиваемого редактируемого поля как метаданные заказа и обновите метаданные элемента заказа
add_action( 'woocommerce_process_shop_order_meta', 'save_order_custom_field_meta_data', 12, 2 );
function save_order_custom_field_meta_data( $post_id, $post ){
    if( isset( $_POST[ 'customer_ref' ] ) ){
        // Сохраните «ссылку клиента» как метаданные заказа
        update_post_meta( $post_id, '_customer_ref', sanitize_text_field( $_POST[ 'customer_ref' ] ) );

        // Обновите существующие метаданные элемента «ссылка на клиента»
        if( isset( $_POST[ 'item_id_ref' ] ) )
            wc_update_order_item_meta( $_POST[ 'item_id_ref' ], 'Редактируемое поле', $_POST[ 'customer_ref' ] );
    }
}

//Вывод поля в письме
?>

<?php if ( get_post_meta( $order->id, '_customer_ref', true ) ) {?>
<?php
    echo '<p><strong>'.__('Редактируемое поле').':</strong> ' . get_post_meta( $order->id, '_customer_ref', true ) . '</p>';
    ?>
<?php } else { ?>

<?php } ?>
//Вывод поля в письме